/* ============================================================================================================================================= /
 * LIBRARY:         Decodifica meteo con chip HKW581
 * FILE:            HKW581_decode_tables.h
 * LAST REV:        1.0
 * AUTHOR:          Ivo Colleoni
 * DEVICE:          PIC18F
 * CREATED:         04/10/2016
 * UPDATED:         
 *
 * DESCRIP:         Tabelle di decodifica per dati meteo
/* ============================================================================================================================================ */

/* STRINGHE DI TESTO ========================================================================================================================== */

//// Tabella meteo giorno e notte con extreme weather == 0
//const unsigned char * hkw581_day_night_fc[16] = {
///* 0*/  "",
///* 1*/  "Sereno",
///* 2*/  "Parzialmente nuvoloso",
///* 3*/  "Molto Nuvoloso",
///* 4*/  "Coperto",
///* 5*/  "Temporali",
///* 6*/  "Pioggia",
///* 7*/  "Neve",
///* 8*/  "Nebbia",
///* 9*/  "Nevischio",
///*10*/  "Rovesci",
///*11*/  "Pioggia leggera",
///*12*/  "Rovesci di neve",
///*13*/  "Temporali",
///*14*/  "Nubi a strati",
///*15*/  "Rovesci di nevischio"};  
//
//// Tabella meteo giorno e notte con extreme weather == 1-2-3 e bit 15 == 0, da leggere sempre con il valore del meteo giorno o notte
//const unsigned char * hkw581_day_night_fc_extreme_w[] = {
///* 0*/  "",
///* 1*/  "Molto caldo",
///* 2*/  "",
///* 3*/  "",
///* 4*/  "",
///* 5*/  "Temporali forti",
///* 6*/  "Pioggia forte",
///* 7*/  "Forte nevicata",
///* 8*/  "Nebbia fitta",
///* 9*/  "Forte nevicata",
///*10*/  "Rovesci violenti",
///*11*/  "",
///*12*/  "Forte nevicata",
///*13*/  "Temporali forti",
///*14*/  "",
///*15*/  "Forte nevicata"};
//
//
//// tabella extreme weather >= 4 con bit 15 == 0
//const unsigned char * hkw581_extreme_w_b15_0[16] = {
///* 0*/  "",
///* 1*/  "",
///* 2*/  "",
///* 3*/  "",
///* 4*/  "Tempesta",
///* 5*/  "Tempesta",
///* 6*/  "Tempesta",
///* 7*/  "Raffiche di vento",
///* 8*/  "Raffiche di vento",
///* 9*/  "Nevischio mattina",
///*10*/  "Nevischio pomeriggio",
///*11*/  "Nevischio notte",
///*12*/  "Polveri sottili",
///*13*/  "Ozono",
///*14*/  "Radiazione solare",
///*15*/  "Inondazione"};
//
//
//// tabelle extreme weather con bit 15 = 1, ATTENZIONE, vanno lette 2 tabelle una per i 2 bit bassi e una per i 2 bit alti (low non so, high = ore di sole)
//const unsigned char * hkw581_extreme_w_b15_1_low[4] = {"Stesso meteo", "Salto 1", "Salto 2", "Salto 3"};
//const unsigned char * hkw581_extreme_w_b15_1_high[4] = {"0-2", "2-4", "5-6", "7-8"};


// Tabella direzione vento 
const unsigned char * hkw581_wind_dir[14] = {"Nord", "Nord Ovest", "Ovest", "Sud Ovest", "Sud", "Sud Est", "Est", "Nord Est", "Variabile", "Fohn", "Bise N/O", "Maestrale N", "Scirocco S", "Tramontana E"};

// Tabella forza vento
// conversione 
const unsigned char * hkw581_wind_str[8] = {"0 Km/h", "1~11 Km/h", "12~29 Km/h", "30~50 Km/h", "50~62 Km/h", "63~75 Km/h", "76~87 Km/h", ">88 Km/h"};

// Tabella Probabilit pioggia
const unsigned char * hkw581_rain_pr[8] = {"0%", "15%", "30%", "45%", "60%", "75%", "90%", "100%"};