/* ============================================================================================================================================= /
 * PROJECT:         Stazione meteo
 * FILE:            Main.h
 * LAST REV:        1.0
 * AUTHOR:          Ivo Colleoni
 * DEVICE:          PIC18F67K22
 * CREATED:         08/12/2016        
 * UPDATED:
 *
 * DESCRIP:         
 *
 * ============================================================================================================================================= /
 * Change History:
 * Rev.             Date                Changes
 /* ============================================================================================================================================ *

 /* I/O PIC18F67K22============================================================================================================================= /
 * RA0:     GPIO non usato
 * RA1:     GPIO non usato
 * RA2:     GPIO non usato
 * RA3:     GPIO non usato
 * RA4:     GPIO non usato
 * RA5:     GPIO non usato
 * RA6:     GPIO non usato
 * RA7:     GPIO non usato
 * RB0:     DCF77_SIGNAL_IN      
 * RB1:     TP_IRQ      
 * RB2:     PCF_INT (OPZIONALE)
 * RB3:     PCF_CLK (OPZIONALE)      
 * RB4:     BUZZER
 * RB5:     
 * RB6:     ICSP CLK
 * RB7:     ICSP DAT
 * RC0:     RTCC OSC   
 * RC1:     RTCC OSC
 * RC2:     ESP8266_CHPD
 * RC3:     I2C SCL
 * RC4:     I2C SDA 
 * RC5:     ESP8266_RST
 * RC6:     ESP8266_UART_TX 
 * RC7:     ESP8266_UART_RX 
 * RD0:     TFT_CS
 * RD1:     TFT_RS
 * RD2:     TFT_WR
 * RD3:     TFT_RST
 * RD4:     SPI_SDO
 * RD5:     SPI_SDI
 * RD6:     SPI_SCK
 * RD7:     TP_CS
 * RE0:     TFT_D10
 * RE1:     TFT_D11
 * RE2:     TFT_D12
 * RE3:     TFT_D13
 * RE4:     TFT_D14
 * RE5:     TFT_D15
 * RE6:     TFT_D16
 * RE7:     TFT_D17
 * RF1:     HKW_CLK_IN
 * RF2:     HKW_DATA_OUT
 * RF3:     HKW_BFR
 * RF4:     HKW_RST
 * RF5:     HKW_Q_OUT
 * RF6:     HKW_DATA_IN
 * RF7:     SD_CS
 * RG0:     HMTRP_EN
 * RG1:     HMTRP_UART_TX
 * RG2:     HMTRP_UART_RX
 * RG3:     TFT_BL
 * RG4:     HMTRP_CONF
 * RG5:     MCLR
 * 
 */

/* CONFIGURATION BITS ========================================================================================================================= */

// CONFIG1L
#pragma config RETEN = ON       // VREG Sleep Enable bit (Enabled)
#pragma config INTOSCSEL = HIGH // LF-INTOSC Low-power Enable bit (LF-INTOSC in High-power mode during Sleep)
#pragma config SOSCSEL = HIGH   // SOSC Power Selection and mode Configuration bits (High Power SOSC circuit selected)
#pragma config XINST = OFF      // Extended Instruction Set (Disabled)

// CONFIG1H
#pragma config FOSC = INTIO2    // Oscillator (Internal RC oscillator)
#pragma config PLLCFG = OFF     // PLL x4 Enable bit (Disabled)
#pragma config FCMEN = OFF      // Fail-Safe Clock Monitor (Disabled)
#pragma config IESO = OFF       // Internal External Oscillator Switch Over Mode (Disabled)

// CONFIG2L
#pragma config PWRTEN = OFF     // Power Up Timer (Disabled)
#pragma config BOREN = SBORDIS  // Brown Out Detect (Enabled in hardware, SBOREN disabled)
#pragma config BORV = 3         // Brown-out Reset Voltage bits (1.8V)
#pragma config BORPWR = ZPBORMV // BORMV Power level (ZPBORMV instead of BORMV is selected)

// CONFIG2H
#pragma config WDTEN = OFF      // Watchdog Timer (WDT disabled in hardware; SWDTEN bit disabled)
#pragma config WDTPS = 1048576  // Watchdog Postscaler (1:1048576)

// CONFIG3L
#pragma config RTCOSC = SOSCREF // RTCC Clock Select (RTCC uses SOSC)

// CONFIG3H
#pragma config CCP2MX = PORTC   // CCP2 Mux (RC1)
#pragma config MSSPMSK = MSK7   // MSSP address masking (7 Bit address masking mode)
#pragma config MCLRE = ON       // Master Clear Enable (MCLR Enabled, RG5 Disabled)

// CONFIG4L
#pragma config STVREN = ON      // Stack Overflow Reset (Enabled)
#pragma config BBSIZ = BB2K     // Boot Block Size (2K word Boot Block size)

// CONFIG5L
#pragma config CP0 = OFF        // Code Protect 00800-03FFF (Disabled)
#pragma config CP1 = OFF        // Code Protect 04000-07FFF (Disabled)
#pragma config CP2 = OFF        // Code Protect 08000-0BFFF (Disabled)
#pragma config CP3 = OFF        // Code Protect 0C000-0FFFF (Disabled)
#pragma config CP4 = OFF        // Code Protect 10000-13FFF (Disabled)
#pragma config CP5 = OFF        // Code Protect 14000-17FFF (Disabled)
#pragma config CP6 = OFF        // Code Protect 18000-1BFFF (Disabled)
#pragma config CP7 = OFF        // Code Protect 1C000-1FFFF (Disabled)

// CONFIG5H
#pragma config CPB = OFF        // Code Protect Boot (Disabled)
#pragma config CPD = OFF        // Data EE Read Protect (Disabled)

// CONFIG6L
#pragma config WRT0 = OFF       // Table Write Protect 00800-03FFF (Disabled)
#pragma config WRT1 = OFF       // Table Write Protect 04000-07FFF (Disabled)
#pragma config WRT2 = OFF       // Table Write Protect 08000-0BFFF (Disabled)
#pragma config WRT3 = OFF       // Table Write Protect 0C000-0FFFF (Disabled)
#pragma config WRT4 = OFF       // Table Write Protect 10000-13FFF (Disabled)
#pragma config WRT5 = OFF       // Table Write Protect 14000-17FFF (Disabled)
#pragma config WRT6 = OFF       // Table Write Protect 18000-1BFFF (Disabled)
#pragma config WRT7 = OFF       // Table Write Protect 1C000-1FFFF (Disabled)

// CONFIG6H
#pragma config WRTC = OFF       // Config. Write Protect (Disabled)
#pragma config WRTB = OFF       // Table Write Protect Boot (Disabled)
#pragma config WRTD = OFF       // Data EE Write Protect (Disabled)

// CONFIG7L
#pragma config EBRT0 = OFF      // Table Read Protect 00800-03FFF (Disabled)
#pragma config EBRT1 = OFF      // Table Read Protect 04000-07FFF (Disabled)
#pragma config EBRT2 = OFF      // Table Read Protect 08000-0BFFF (Disabled)
#pragma config EBRT3 = OFF      // Table Read Protect 0C000-0FFFF (Disabled)
#pragma config EBRT4 = OFF      // Table Read Protect 10000-13FFF (Disabled)
#pragma config EBRT5 = OFF      // Table Read Protect 14000-17FFF (Disabled)
#pragma config EBRT6 = OFF      // Table Read Protect 18000-1BFFF (Disabled)
#pragma config EBRT7 = OFF      // Table Read Protect 1C000-1FFFF (Disabled)

// CONFIG7H
#pragma config EBRTB = OFF      // Table Read Protect Boot (Disabled)

/* I/O ========================================================================================================================================== */
#define BUZZER      LATBbits.LATB4

/* PERSONALIZZAZIONI ============================================================================================================================ */

// costanti di calibrazione sensori locali
#define HDC1080_TEMP_CAL        (-3.654)//(-6.74)
#define HDC1080_HUMID_CAL       (4.7885)// (1.95)
#define LPS25HB_ONE_POINT_CAL   (-9.050)//-9.82
#define LPS25HB_TEMP_CAL        (-3.754)//(-4.18)

// costanti di calibrazione sensori remoti
#define HDC1080_REM_TEMP_CAL    0//(-1.10)
#define HDC1080_REM_HUMID_CAL   0//
//#define LPS25HB_ONE_POINT_CAL                                                  // definito in main.h del modulo remoto,  un valore impostato direttamente nel sensore
#define LPS25HB_REM_TEMP_CAL    (3.2483)// (5.93)

// tempo di scansione dei sensori in secondi
#define TEMP_SCANS_SENS_1       5       
#define TEMP_SCANS_SENS_2       10       
#define TEMP_SCANS_SENS_3       30       
#define TEMP_SCANS_SENS_4       60       
#define TEMP_SCANS_SENS_5       300       
#define TEMP_SCANS_SENS_6       600
#define TEMP_SCANS_SENS_7       1200
#define TEMP_SCANS_SENS_8       1800

// tempo massimo tentativo sync DCF77 in minuti
#define DCF77_MINUTE_LIMIT      9

/* COSTANTI ===================================================================================================================================== */
#define XTAL_FREQ               64                                                      // definisco la frequenza per Libreria Delay

#define ON                      1
#define OFF                     0

#define DCF77_DISABLED          0
#define DCF77_ENABLED           1

#define LOCAL                   0
#define REMOTE                  1

// costanti per inizializzazione pulsanti
#define SW_INIT_4               0x80

#define SW_SETUP_INCR           0x81
#define SW_SETUP_OK_EXT         0x90
#define SW_RESC_ESC             0x91
#define SW_LOG_PAGE             0xA0

// costanti per ritorni touch e pulsanti premuti
#define T_SW_1                  1
#define T_SW_2                  2
#define T_SW_3                  3
#define T_SW_4                  4   
#define T_SW_5                  5
#define T_SW_6                  6
#define T_SW_7                  7
#define T_SW_8                  8
#define T_SW_9                  9
#define T_SW_10                 10
#define T_SW_11                 11
#define T_SW_12                 12
#define T_SW_13                 13
#define T_SW_14                 14
#define T_SW_15                 15
#define T_SW_16                 16
#define T_HOUR                  20
#define T_METEO                 21
#define T_LOCAL_SENSOR          22
#define T_REMOTE_SENSOR         23
#define T_SETUP_R_1             24
#define T_SETUP_R_2             25
#define T_SETUP_R_3             26
#define T_SETUP_R_4             27
#define T_SETUP_R_5             28
#define T_SETUP_R_6             29
#define T_SETUP_R_7             30
#define T_SETUP_R_8             31
#define T_SETUP_R_9             32
#define T_SW_PLUS               33
#define T_SW_LESS               34
#define T_SW_OK                 35
#define T_SW_EXIT               36
#define T_SW_RSC                59
#define T_LIGHT_LEV             37
#define T_ON_HOURS              38
#define T_ON_MINUTES            39
#define T_OFF_HOURS             40
#define T_OFF_MINUTES           41
#define T_SETUP_HOURS           42
#define T_SETUP_MINUTES         43
#define T_SETUP_DAY             44
#define T_SETUP_MONTH           45
#define T_SETUP_YEAR            46
#define T_SETUP_DAY_W           47
#define T_SETUP_LOCAL_SENSOR    48
#define T_SETUP_REMOTE_SENSOR   49
#define T_SETUP_PRESS_TO_WRITE  50
#define T_SETUP_LOCAL_ALTITUDE  51
#define T_SETUP_WIFI_EN         52
#define T_SETUP_WIFI_SCAN_SSID  53
#define T_SETUP_WIFI_SSID_1     54
#define T_SETUP_WIFI_SSID_2     55
#define T_SETUP_WIFI_SSID_3     56
#define T_ARROW_NEXT            57
#define T_ARROW_PREV            58
#define T_SETUP_DCF77           59
#define T_SETUP_CET_CEST        60

// PAGINE E CHIAMATE TOUCH ROUTINE
#define MAIN_PAGE               0
#define SETUP_1_PAGE            1
#define SETUP_2_PAGE            2
#define LOG_PAGE                3
#define STA_PAGE                4

#define TOUCH_SETUP_MENU        50  // SOLO PER TOUCH ROUTINE
#define TOUCH_SETUP_INCR        51  // SOLO PER TOUCH ROUTINE
#define TOUCH_SETUP_LIGHT       52          
#define TOUCH_SETUP_TIME        53
#define TOUCH_SETUP_SENSORS     54
#define TOUCH_SETUP_WIFI        55
#define TOUCH_SETUP_WIFI_SSID   56
#define TOUCH_LOG               57
#define TOUCH_STA               58

/* ============================================================================================================================================= /
 * FUNCTION:        DefineIO
 * Overview:        Definizione e inizializzazione ingressi e uscite
/* ============================================================================================================================================ */
void Define_IO(void) {
    ANCON0 =    0b00000000;                                                             // tutti digital I/O
    ANCON1 =    0b00000000;
    ANCON2 =    0b00000000;
    
    PORTA =     0b00000000;
    LATA =      0b00000000;                                                             
    TRISA =     0b00000000;
    
    PORTB =     0b00000000;                                                             
    LATB =      0b00000000;                                                             
    TRISB =     0b00001111;
    
    PORTC =     0b00000000;                                                             
    LATC =      0b00000000;                                                             
    TRISC =     0b11011011;
    
    PORTD =     0b00000000;                                                             
    LATD =      0b10000000;                                                             
    TRISD =     0b00100000;
    
    PORTE =     0b00000000;                                                             
    LATE =      0b00000000;                                                             
    TRISE =     0b00000000;
    
    PORTF =     0b00000000;                                                             
    LATF =      0b10000000;                                                             
    TRISF =     0b00101100;
    
    PORTG =     0b00000000;                                                             
    LATG =      0b00000000;                                                             
    TRISG =     0b00100110;
}

/* ============================================================================================================================================= /
 * FUNCTION:        Module_settings
 * Overview:        Configurazioni dei moduli interni
/* ============================================================================================================================================ */
void Module_settings(void) {
    INTCON2bits.RBPU = 1;                                                               // disabilito resistenze pull up su PORTB
    PADCFG1bits.RDPU = 0;                                                               // PORTD
    PADCFG1bits.REPU = 0;                                                               // PORTE
    
    OSCCONbits.IRCF0 = 1;                                                               // oscillatore interno 16 MHz
    OSCCONbits.IRCF1 = 1;    
    OSCCONbits.IRCF2 = 1;    
    OSCTUNEbits.PLLEN = 1;                                                              //0= PLL disabilitata // =1 PLL x4 = 64Mhz
        
//    OSCCON2bits.SOSCGO = 1;                                                             // avvio oscillatore secondario per RTCC
    
    CCP1CONbits.CCP1M0 = 0;                                                             // disabilito tutti i comparatori
    CCP1CONbits.CCP1M1 = 0;
    CCP1CONbits.CCP1M2 = 0;
    CCP1CONbits.CCP1M3 = 0;
    
    CCP2CONbits.CCP2M0 = 0;
    CCP2CONbits.CCP2M1 = 0;
    CCP2CONbits.CCP2M2 = 0;
    CCP2CONbits.CCP2M3 = 0;

    CCP3CONbits.CCP3M0 = 0;
    CCP3CONbits.CCP3M1 = 0;
    CCP3CONbits.CCP3M2 = 0;
    CCP3CONbits.CCP3M3 = 0;
    
    CCP4CONbits.CCP4M0 = 0;
    CCP4CONbits.CCP4M1 = 0;
    CCP4CONbits.CCP4M2 = 0;
    CCP4CONbits.CCP4M3 = 0;
        
    CCP5CONbits.CCP5M0 = 0;
    CCP5CONbits.CCP5M1 = 0;
    CCP5CONbits.CCP5M2 = 0;
    CCP5CONbits.CCP5M3 = 0;
    
    CCP6CONbits.CCP6M0 = 0;
    CCP6CONbits.CCP6M1 = 0;
    CCP6CONbits.CCP6M2 = 0;
    CCP6CONbits.CCP6M3 = 0;
    
    CCP7CONbits.CCP7M0 = 0;
    CCP7CONbits.CCP7M1 = 0;
    CCP7CONbits.CCP7M2 = 0;
    CCP7CONbits.CCP7M3 = 0;
    
    CCP8CONbits.CCP8M0 = 0;
    CCP8CONbits.CCP8M1 = 0;
    CCP8CONbits.CCP8M2 = 0;
    CCP8CONbits.CCP8M3 = 0;
    
    CCP9CONbits.CCP9M0 = 0;
    CCP9CONbits.CCP9M1 = 0;
    CCP9CONbits.CCP9M2 = 0;
    CCP9CONbits.CCP9M3 = 0;
    
    CCP10CONbits.CCP10M0 = 0;
    CCP10CONbits.CCP10M1 = 0;
    CCP10CONbits.CCP10M2 = 0;
    CCP10CONbits.CCP10M3 = 0;
    

/* INTERRUPT GLOBALE e PRIORITA'*/
    RCONbits.IPEN = 1;
    INTCONbits.GIEH = 1;
    INTCONbits.GIEL = 1;
    
 /* Configurazioni per PWM su CCP4 - RG3   */
    TRISGbits.TRISG3 = 1;                                                               // disabilito uscita  
    
    CCP4CONbits.CCP4M0 = 0;                                                             // CCP4 in PWM
    CCP4CONbits.CCP4M1 = 0;
    CCP4CONbits.CCP4M2 = 1;
    CCP4CONbits.CCP4M3 = 1;
    
//    CCP4CONbits.P4M0 = 0;                                                               // Single output: PxA, PxB, PxC and PxD are controlled by steering
//    CCP4CONbits.P4M1 = 0;
    
    CCPTMRS1bits.C4TSEL0 = 0 ;                                                          // timer 1/2 associato a CCP4 (PWM associa in automatico Timer 2)
    CCPTMRS1bits.C4TSEL1 = 0 ;
    
    // PWM 4Khz
    PR2 = 249;                                                                          // Periodo PWM
    CCP4CONbits.DC4B = 0;                                                               // 2 bits duty low
//    CCPR4L = 200;
    
    T2CONbits.T2CKPS0 = 0;                                                              // prescaler 16
    T2CONbits.T2CKPS1 = 1;
      
    T2CONbits.TMR2ON = 1;
    TRISGbits.TRISG3 = 0;                                                               // abilito uscita   
}