// struttura valori sensori (ripetuta)
typedef struct {
    float temp_hdc1080;
    float humidity;
    float press;
    float temp_lps25;
    veml6075_uv uv_readed;    
} sensors_values;

typedef struct {
    unsigned int temp_hdc1080_raw;
    unsigned int humidity_raw;
    unsigned long press_raw;
    signed int temp_lps25_raw;
    veml6075_uv_raw uv_readed_raw;
} sensors_raw_values;

void Back_2 (unsigned char _page);
void Draw_layout(unsigned char _page);
void Draw_switch(unsigned char _pressed);
void Draw_meteo(unsigned char meteo_page);
void Draw_moon_phase(void);
void Update_time(void);
void Get_local_sensors_values(void);
void Get_remote_sensors_values(void);
void Write_sensor_values(sensors_values * _value_actual, sensors_values * _value_min, sensors_values * _value_max);
float Normalize_press(float _press_absolute, float _temp, unsigned int _local_altitude);
void DCF77_manage_loop(void);
unsigned char Check_dcf77_received(dcf77_decoded_data * _save_loc);
void Check_time_2_sync(void);
void Calc_meteo_time(unsigned char _meteo_zone, signed char _time_zone_utc, unsigned char _cet_cest_flag);
rtcc_data Set_time_zone(rtcc_data _rtcc_time, signed char _time_zone_utc);
void Wifi_connect (unsigned char * _ssid, unsigned char * _password);
void Wifi_open_server(void);
void Wifi_close_server(void);
void Wifi_check_con(unsigned char _forced);
void Wifi_check_incoming(void);
void Wifi_send_settings (unsigned char _active_connection);
void Wifi_send_rt_data (unsigned char _active_connection);
void Wifi_send_log_data (unsigned char _active_connection, unsigned char _selection);
void Wifi_send_debug_log(unsigned char _active_connection);
void Clear_buffer (unsigned char * _buffer);
void Wifi_close_connection(unsigned char _connection_2_close);
void Save_sensors_log(sensors_raw_values * _values, unsigned char _type);
unsigned char Plot_log_chart(unsigned char _chart_2_plot);
void Export_sensors_log(const unsigned char * _file_name);
void Setup_time_manual(void);
void Setup_utc(void);
void Setup_meteo_region (void);
void Setup_sensors(void);
void Setup_wifi(void);
void Wifi_select_ssid(void);
void Setup_light(void);
void Calibrate_touch(void);
void Hardware_check(void);
void Test_sensors(void);
void DCF77_check(void);
void Set_remote_aq_time (unsigned char _time);
unsigned char Touch_screen_manage_loop(unsigned char _page_touch);
unsigned char Handle_keyboard(void);
void Drawing(void);
void Save_eeprom_default_variables(void);
void Load_eeprom_variables(void);
void Save_meteo_data_eeprom(unsigned char _meteo_time);
void Load_meteo_data_eeprom(void);
void Init_meteo_data(void);
unsigned char Inc_pbcd(unsigned char _value, unsigned char _min, unsigned char _max);
unsigned char Dec_pbcd(unsigned char _value, unsigned char _min, unsigned char _max);
unsigned char Bcd_2_dec(unsigned char _byte);
unsigned char Dec_2_bcd(unsigned char _value);
unsigned char * Create_timestamp_string (unsigned char _eeprom_dev_address, volatile unsigned int _eeprom_addr, unsigned char _data_2_read);
unsigned char * Float_2_string (float _float, unsigned char _digits_int, unsigned char _digits_part, unsigned char _zero_cleaning);
