/* ============================================================================================================================================= /
 * LIBRARY:         Gestione TFT ILI9325
 * FILE:            TFT_ILI9325_settings.h
 * LAST REV:        1.0
 * AUTHOR:          Ivo Colleoni
 * DEVICE:          PIC18F
 * CREATED:         17/10/2016
 * UPDATED:   
 *
 * DESCRIP:         Settaggi per libreria TFT_ILI9325.c
/* ============================================================================================================================================ */
// font e immagini inclusi nel progetto, commentare i font non utilizzati

#include    "GLCD_Font_lucida_sans_10x16.h"          // font principale
#include    "GLCD_Font_dense_23x56_only_numbers.h"   // font ora
#include    "GLCD_Font_segoe_20x24.h"                // font giorno settimana
#include    "GLCD_Font_segoe_10x15_only_numbers.h"   // font data

/* COSTANTI DI CONFIGURAZIONE ================================================================================================================= */
// Modalit di trasmissione 8/16 bit
#define TFT_8_BIT_DATA
//#define TFT_16BIT_DATA

// Orientamento del display
#define TFT_PORTRAIT
//#define TFT_LANDSCAPE
//#define TFT_PORTRAIT_180
//#define TFT_LANDSCAPE_180

// Risoluzione
#define V_RESOLUTION        320
#define H_RESOLUTION        240

// numero di pixel da leggere da SD(byte del buffer = pixel *2) 
// se non  usata una scheda SD commentare
#define SD_BUFFER 50 // 1=lettura e scrittura pixel per pixel 

/* I/O ======================================================================================================================================== */
// CONNESSIONE PIN DB10-10 USATI PER 8 BIT O COME LSB 16 BIT
#define TFT_DATA_D10_17_WRITE  LATE
#define TFT_DATA_D10_17_READ   PORTE
#define TFT_DATA_D10_17_DIR    TRISE

// COMMENTARE LA SECONDA PORTA SE SI USA IN MODALITA' 8 BIT E CONNETTERE I PID D0-D9 A MASSA
//#define TFT_DATA_D1_8_WRITE   LATB
//#define TFT_DATA_D1_8_READ    PORTB
//#define TFT_DATA_D1_8_DIR     TRISB

#define TFT_CS              LATDbits.LATD0
#define TFT_RS              LATDbits.LATD1
#define TFT_WR              LATDbits.LATD2 
#define TFT_RST             LATDbits.LATD3

// COMMENTARE TFT_RD SE NON USATE FUNZIONI IN LETTURA E CONNETTERE IL PIN A VCC
//#define TFT_RD              

// COMMENTARE TFT_BACKILL SE LA RETROILLUMINAZIONE  GESTITA TRAMITE PWM 
//    #define TFT_BACKILL
