/* ============================================================================================================================================= /
 * LIBRARY:         Gestione Touch screen con controller XPT2046
 * FILE:            XPT2046.c
 * LAST REV:        1.0
 * AUTHOR:          Ivo Colleoni
 * DEVICE:          PIC18F
 * CREATED:         06/11/2016
 * UPDATED:         
 *
 * DESCRIP:         Settaggi per libreria XPT2046.c
/* ============================================================================================================================================ */

/* COSTANTI DI CONFIGURAZIONE ================================================================================================================= */
//#define XPT2046_SPI_MODULE_1
#define XPT2046_SPI_MODULE_2

#define XPT2046_SPI_CLOCK   MASTER_FOSC_64  // clock SPI, definire in base al clock pic usato
                                            // MASTER_FOSC_4
                                            // MASTER_FOSC_16
                                            // MASTER_FOSC_64
                                            // MASTER_TMR2_2

#define XPT2046_AVG_FACTOR  128         // 1(no average)-2-4-8-16-32-64-128-256 
                                        // Clock @64MHz SPI Clock @1MHz
                                        // AVG = 1 TAQ = 56uS
                                        // AVG = 8 TAQ = 0.450ms
                                        // AVG = 32 TAQ = 1mS
                                        // AVG = 256 TAQ = 10mS

// Orientamento del display, settato in TFT_ILI9325_settings
//#define TFT_PORTRAIT
//#define LANDSCAPE
//#define PORTRAIT_180
//#define LANDSCAPE_180

// Risoluzione, settata in TFT_ILI9325_settings
//#define V_RESOLUTION        320
//#define H_RESOLUTION        240

/* I/O ======================================================================================================================================== */
#define XPT2046_CS      LATDbits.LATD7 
#define XPT2046_IRQ     PORTBbits.RB1