/* ============================================================================================================================================= /
 * LIBRARY:         Font per librerie display grafici
 * FILE:            TFT_Font_segoe_10x15_only_numbers.h
 * LAST REV:        1.0
 * AUTHOR:          Ivo Colleoni
 * DEVICE:          PIC18F
 * CREATED:         09/04/2017
 * UPDATED:
 *
 * DESCRIP:         Font Segoe 10x15 a codifica verticale (ogni byte contiene i bit in altezza del carattere, 2 byte per altezza).
 *                  I primi 5 byte contengono i parametri del font, dal sesto byte sono codificati i caratteri ASCII da 46 a 58 ./0123456789:
 *                   codificato il carattere per i gradi centigradi.
 * NOTE:            256 byte of program memory
 *                  corrisponde al font completo Segoe 20x24
/* ============================================================================================================================================= /
 * Change History:
 * Rev.             Date                Changes
 * 1.0              09/04/2017
/* ============================================================================================================================================ */

const unsigned char font_segoe_10x15[] = {
    0x0A,                   // larghezza
    0x0F,                   // altezza
    0x01,                   // pixel di spazio tra i caratteri
    0x2F,                   // first char offset che indica l'offset da sottrarre al carattere ASCII per arrivare al carattere giusto
    0x02,                   // numero di byte di altezza 
    
    
    0x00, 0x00, 0x00, 0x60, 0x00, 0x78, 0x00, 0x3F, 0xC0, 0x07, 0xF8, 0x01, 0x3E, 0x00, 0x0F, 0x00, 0x01, 0x00, 0x00, 0x00,  // Code for char /
    0xF0, 0x0F, 0xFC, 0x3F, 0x0E, 0x78, 0x03, 0x60, 0x03, 0x60, 0x03, 0x60, 0x0F, 0x38, 0xFE, 0x1F, 0xF8, 0x07, 0x00, 0x00,  // Code for char 0
    0x00, 0x00, 0x00, 0x00, 0x0C, 0x00, 0x0E, 0x00, 0x06, 0x00, 0xFF, 0x7F, 0xFF, 0x7F, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  // Code for char 1
    0x00, 0x70, 0x06, 0x78, 0x07, 0x6C, 0x03, 0x66, 0x03, 0x63, 0x83, 0x61, 0xC7, 0x61, 0xFE, 0x60, 0x3C, 0x60, 0x00, 0x00,  // Code for char 2
    0x00, 0x30, 0x02, 0x60, 0xC3, 0x60, 0xC3, 0x60, 0xC3, 0x60, 0xE7, 0x60, 0xBE, 0x31, 0x1C, 0x3F, 0x00, 0x1E, 0x00, 0x00,  // Code for char 3
    0x00, 0x0E, 0x00, 0x0F, 0xC0, 0x0D, 0xE0, 0x0C, 0x38, 0x0C, 0x0E, 0x0C, 0xFF, 0x7F, 0xFF, 0x7F, 0x00, 0x0C, 0x00, 0x0C,  // Code for char 4
    0x00, 0x00, 0xFF, 0x70, 0xFF, 0x60, 0xC3, 0x60, 0xC3, 0x60, 0xC3, 0x60, 0xC3, 0x71, 0x83, 0x3F, 0x00, 0x1F, 0x00, 0x00,  // Code for char 5
    0xE0, 0x0F, 0xF8, 0x1F, 0x9E, 0x31, 0xC6, 0x60, 0xC3, 0x60, 0xC3, 0x60, 0xC3, 0x60, 0xC3, 0x31, 0x83, 0x3F, 0x00, 0x0F,  // Code for char 6
    0x03, 0x00, 0x03, 0x00, 0x03, 0x60, 0x03, 0x7E, 0x83, 0x7F, 0xE3, 0x07, 0xFB, 0x00, 0x3F, 0x00, 0x0F, 0x00, 0x03, 0x00,  // Code for char 7
    0x1C, 0x1F, 0xFE, 0x3F, 0xE7, 0x71, 0xC3, 0x60, 0xC3, 0x60, 0xC3, 0x60, 0xE7, 0x71, 0xFE, 0x3F, 0x1C, 0x1F, 0x00, 0x00,  // Code for char 8
    0x7C, 0x00, 0xFE, 0x70, 0xC7, 0x61, 0x83, 0x61, 0x83, 0x61, 0x83, 0x71, 0xC7, 0x38, 0xFE, 0x1F, 0xF8, 0x07, 0x00, 0x00   // Code for char 9
    };







                          
                          
